local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
if not mHud or not mHud:GetModule("Configuration", true) then return end
local barConfig = [[ return function(db, id, self)
		local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
		local mBar = LibStub("AceAddon-3.0"):GetAddon("mBar")

		local t =  {
			abyss = {
				type = "group",
				order = 90,
				name = "Abyss",
				childGroups = "tab",
	 			plugins = {},
				args = {
					abyssheader = { order = 1, type = "header", name = "Abyss" },
				},
			},
		}
		
		
		t.abyss.args.abysstoggle = {
			type = "toggle",
			name = "Use abyss",
			order = 10,
			get = function() return db.abyss.active end,
			set = function(info, value) db.abyss.active = value; self:UpdateConfig(id) end,
		}
		
		t.abyss.args.abyssspace = { order = 11, type = "description", name = " " }
		
		t.abyss.args.abysssize = {
			type = "range",
			name = "Size",
			order = 20,
			get = function() return db.abyss.size end,
			set = function(info, value) db.abyss.size = value end,
			min = 0.01, max = 50, bigStep = 0.1,
			disabled = function() return not db.abyss.active end,
		}
		
		t.abyss.args.abysshold = {
			type = "range",
			name = "Seconds delay",
			order = 21,
			get = function() return db.abyss.hold end,
			set = function(info, value) db.abyss.hold = value end,
			min = 0.01, max = 20, bigStep = 0.1,
			disabled = function() return not db.abyss.hold end,
		}
		
		if mHud:GetModule("GradientColor", true) then
			t.abyss.args.bgcolornormal = {
				type = "select",
				name = "Colors - Normal",
				order = 30,
				values = mHud.mColorTemplateConfig:List(2, "Normal"),
				get = function() return db.abyss.gradientColor end,
				set = function(info, value) db.abyss.gradientColor = value; self:UpdateConfig(id) end,
				disabled = function() return not db.abyss.active end,
			}
			t.abyss.args.bgcolorcombat = {
				type = "select",
				name = "Colors - Combat",
				order = 31,
				values = mHud.mColorTemplateConfig:List(2, "Combat", true),
				get = function() return db.abyss.gradientColorCombat or "nil" end,
				set = function(info, value) db.abyss.gradientColorCombat = value; if value == "nil" then db.abyss.gradientColorCombat = nil end; self:UpdateConfig(id) end,
				disabled = function() return not db.abyss.active end,
			}
		end
		
		if mHud:GetModule("GradientAlpha", true) then
			t.abyss.args.bgalphanormal = {
				type = "select",
				name = "Alpha - Normal",
				order = 40,
				values = mHud.mAlphaTemplateConfig:List(2, "Normal"),
				get = function() return db.abyss.gradientAlpha end,
				set = function(info, value) db.abyss.gradientAlpha = value; self:UpdateConfig(id) end,
				disabled = function() return not db.abyss.active end,
			}
			t.abyss.args.bgalphacombat = {
				type = "select",
				name = "Alpha - Combat",
				order = 41,
				values = mHud.mAlphaTemplateConfig:List(2, "Combat", true),
				get = function() return db.abyss.gradientAlphaCombat or "nil" end,
				set = function(info, value) db.abyss.gradientAlphaCombat = value; if value == "nil" then db.abyss.gradientAlphaCombat = nil end; self:UpdateConfig(id) end,
				disabled = function() return not db.abyss.active end,
			}
		end
		
		t.abyss.args.toggletext = {
			type = "toggle",
			name = "Display text",
			order = 50,
			get = function() return db.abyss.text.active end,
			set = function(info, value) db.abyss.text.active = value; self:UpdateConfig(id) end,
		}
		
		t.abyss.args.abysstextspace = { order = 54, type = "description", name = " " }
		
		t.abyss.args.color = {
			order = 55,
			type = "color",
			name = "Font Color",
			get = function() return db.abyss.text.color.r, db.abyss.text.color.g, db.abyss.text.color.b, db.abyss.text.color.a end,
			set = function(info, r, g, b, a)
				db.abyss.text.color.r=r
				db.abyss.text.color.g=g
				db.abyss.text.color.b=b
				db.abyss.text.color.a=a
				self:UpdateConfig(id);
			end,
		}
		
		t.abyss.args.font = {
			order = 56,
			type = "select",
			name = "Font Face",
			values = mBar.media:List("font"),
			get = function()
				for k,v in ipairs(mBar.media:List("font")) do
					if v == db.abyss.text.font then return k end
				end
			end,
			set = function(info, value)
				for k,v in ipairs(mBar.media:List("font")) do
					if k == value then
						db.abyss.text.font = v
						self:UpdateConfig(id);
					end
				end
				return
			end,
		}
		
		t.abyss.args.toggleanchor = {
			type = "toggle",
			name = "Anchor to spark",
			order = 60,
			get = function() return db.abyss.text.anchorToSpark end,
			set = function(info, value) db.abyss.text.anchorToSpark = value; self:UpdateConfig(id) end,
		}
		
		t.abyss.args.anchorTo = {
			order = 61,
			type = "select",
			name = "Anchor To",
			values = self:AnchorList(id),
			get = function() return self:AnchorGet(db.abyss.text.anchor.to) end,
			set = function(info, value) self:AnchorSet(value, db.abyss.text); self:UpdateConfig(id) end,
			disabled = function() return not db.abyss.active or db.abyss.text.anchorToSpark end,
		}
		t.abyss.args.point = {
			order = 62,
			type = "select",
			name = "Point",
			values = self.relativeList,
			get = function() return db.abyss.text.anchor.point end,
			set = function(info, value) db.abyss.text.anchor.point = value; self:UpdateConfig(id) end,
			disabled = function() return not db.abyss.active end,
		}
		t.abyss.args.relativePoint = {
			order = 63,
			type = "select",
			name = "Relative Point",
			values = self.relativeList,
			get = function() return db.abyss.text.anchor.relative end,
			set = function(info, value) db.abyss.text.anchor.relative = value; self:UpdateConfig(id) end,
			disabled = function() return not db.abyss.active end,
		}
		
		return t
		end]]
local bulkConfig = nil
local moduleConfig = nil
mHud:GetModule("Configuration"):NewModuleConfig("Abyss", moduleConfig, barConfig, bulkConfig)
