local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
local mBar = LibStub("AceAddon-3.0"):GetAddon("mBar")
local module = mHud:NewModule("Background")

mHud.defaults.profile.bar['*'].background = {
	active = true,
	color = { r = 1, g = 1, b = 1, a = 0.10 }, -- Color if gradient color isn't active
	gradientAlpha = "Background",
	gradientAlphaCombat = nil,
	gradientColor = "Background",
	gradientColorCombat = nil,
}


module.colorTemplates = {
	Normal = {
		Background = {
			[1] = { v = 1.0, c = { r = 1.00, g = 1.00, b = 1.00 }},
			[2] = { v = 0.5, c = { r = 1.00, g = 1.00, b = 1.00 }},
			[3] = { v = 0.0, c = { r = 1.00, g = 0.00, b = 0.00 }},
		},
	},
}

module.alphaTemplates = {
	Normal = {
		Background = {
			[1] = { v = 1.00, c = { a = 0.00, b = "BLEND" }},
			[2] = { v = 0.99, c = { a = 0.02, b = "BLEND" }},
			[3] = { v = 0.50, c = { a = 0.10, b = "BLEND" }},
			[4] = { v = 0.01, c = { a = 0.20, b = "BLEND" }},
			[5] = { v = 0.001, c = { a = 0.00, b = "BLEND" }},
			[6] = { v = 0.0, c = { a = 0.00, b = "BLEND" }},
		},
	},
	Combat = {
		Background = {
			[1] = { v = 1.00, c = { a = 0.00, b = "BLEND" }},
			[2] = { v = 0.99, c = { a = 0.03, b = "BLEND" }},
			[3] = { v = 0.50, c = { a = 0.10, b = "BLEND" }},
			[4] = { v = 0.01, c = { a = 0.20, b = "BLEND" }},
			[5] = { v = 0.001, c = { a = 0.00, b = "BLEND" }},
			[6] = { v = 0.0, c = { a = 0.00, b = "BLEND" }},
		},
	},
}

function module:OnEnable() self:RegisterEvents() end
function module:OnDisable() self:UnegisterEvents() end

function module:RegisterEvents()

	self:RegisterMessage("MBAR_CREATED", "BarCreated")
	self:RegisterMessage("MBAR_CONFIG_UPDATE", "BarConfigChange")
	
end


function module:UnegisterEvents()

	self:UnregisterMessage("MBAR_CREATED")
	self:UnregisterMessage("MBAR_CONFIG_UPDATE")
	
end


function module:BarCreated(_, f)
	
	self:Debug("BarCreated")
	if f.db.background.active then
		if not f.background then f.background = f:CreateTexture(nil, "BACKGROUND") end
		f.background:Show()
		f.background:SetAllPoints(f)
		f.background:SetVertexColor(f.db.background.color.r, f.db.background.color.g, f.db.background.color.b, f.db.background.color.a)
	end
	
end

function module:BarConfigChange(_, f)
	if not f.background and f.db.background.active then self:BarCreated(nil, f) end
	if f.background then
		if f.db.background.active then
			f.background:SetTexture(f.bar:GetTexture())
			mBar:PaintTexture(f.background, 0, 1)
		else
			f.background:Hide()
		end
	end
end
