if select(2, UnitClass("player")) ~= "DRUID" then return end
local mBar = LibStub("AceAddon-3.0"):GetAddon("mBar")
local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
local LibDruidMana = LibStub("LibDruidMana-1.0")
local module = mBar:NewModule("DruidMana")
module.events = { "UPDATE_SHAPESHIFT_FORM" }
module.description = "Druid Mana"

local e = CreateFrame("frame", nil)
module.next = GetTime() + 2
module.activeTimer = true
e:SetScript("OnUpdate", function() module:OnUpdate() end)

module.colorTemplates = {
	Normal = {
		Mana = {
			[1] = { v = 1.0, c = { r = 0.00, g = 0.00, b = 1.00 }},
			[2] = { v = 0.0, c = { r = 0.50, g = 0.50, b = 1.00 }},
		},
	},
}

function module:OnUpdate()
	if self.next > GetTime() then return end
	self.next = GetTime() + 2
	self:OnEvent()
end

function module:OnEvent()
	if self.bars["player"] then
		if UnitPowerType("player") ~= 0 then
			if LibDruidMana:GetMaximumMana() > 0 then
				local value = self:GetUnitValue("player")
				for id, frame in pairs(self.bars["player"]) do
					self:Debug("Update frame: "..frame.id)
					mBar:SetValue(frame, value)
				end
				
				-- Enable timer and show frames
				if module.activeTimer == false then
					for id, frame in pairs(self.bars["player"]) do frame:SetAlpha(1) end
					module.activeTimer = true
					e:SetScript("OnUpdate", function() module:OnUpdate() end)
				end
			end
		else
			-- Disable timer and hide frames
			if module.activeTimer == true then
				for id, frame in pairs(self.bars["player"]) do frame:SetAlpha(0) end
				module.activeTimer = false
				e:SetScript("OnUpdate", nil)
			end
		end
	end
end

function module:GetUnitValue(unit)
	if LibDruidMana:GetCurrentMana() > 0 then return LibDruidMana:GetCurrentMana() / LibDruidMana:GetMaximumMana() end
	return 0
end

function module:GetUnitMax(unit)
	return LibDruidMana:GetMaximumMana()
end

function module:GetColor(f)
	return 0, 0, 1 -- mana
end
