if select(2, UnitClass("player")) ~= "DRUID" and select(2, UnitClass("player")) ~= "ROGUE" then return end

local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
local module = mHud:NewModule("EnergyTicker")
mHud.mPowerTicker:Embed(module)

mHud.defaults.profile.bar['*'].energyticker = {
	gradientColor = "EnergyTicker",
	gradientAlpha = "EnergyTicker",
}

module.rTab = { }

module.type = 3 -- energy
module.firstTick = 0
module.last = 200
module.loop = 0

module.colorTemplates = {
	Normal = {
		EnergyTicker = {
			[1] = { v = 1.0, c = { r = 1.00, g = 1.00, b = 1.00 }},
		},
	},
}

module.alphaTemplates = {
	Normal = {
		EnergyTicker = {
			[1] = { v = 1.00, c = { a = 1.00, b = "BLEND" }},
			[2] = { v = 0.50, c = { a = 1.00, b = "BLEND" }},
			[3] = { v = 0.10, c = { a = 0.00, b = "BLEND" }},
			[4] = { v = 0.00, c = { a = 0.00, b = "BLEND" }},
		},
	},
}

function module:OnTickerEnable( )
	self.event:SetScript("OnEvent", function() self:OnEvent() end)
	self:RegisterEvents( )
end

function module:OnTickerDisable() self:UnregisterEvents() end

function module:RegisterEvents()
	self.event:RegisterEvent("UNIT_ENERGY")
	self.event:RegisterEvent("UPDATE_STEALTH")
end
function module:UnregisterEvents()
	self.event:UnregisterEvent("UNIT_ENERGY")
	self.event:UnregisterEvent("UPDATE_STEALTH")
end

function module:OnEvent()
	if arg1 == "player" or event == "UPDATE_STEALTH" then
		if UnitMana("player") > self.last then -- gain
			self.firstTick = GetTime()
		end
		if event == "UNIT_ENERGY" then self.active = true end
		self:InitTicker()
		self.loop = 0
		self.last = UnitMana("player")
	end
end

function module:OnKillTicker()
	if self.active ~= true then return end
	self.loop = self.loop + 1
	if self.loop > mHud.db.profile.ticker.loop then
		self.loop = 0
	else
		self:Debug("Loop: "..self.loop)
		self:InitTicker()
	end
end

function module:OnTickerUpdate(f)

	if f.db.energyticker.gradientColor and mHud:GetModule("GradientColor", true) then
		self.rTab = mHud:GetModule("GradientColor"):GetProfile(f, f.db.energyticker.gradientColor, f.db.energyticker.gradientColorCombat, self.pos)
		f.ticker:SetVertexColor(self.rTab.r, self.rTab.g, self.rTab.b)
	end
	
	if f.db.energyticker.gradientAlpha and mHud:GetModule("GradientAlpha", true) then
		self.rTab = mHud:GetModule("GradientAlpha"):GetProfile(f, f.db.energyticker.gradientAlpha, f.db.energyticker.gradientAlphaCombat, self.pos)
		f.ticker:SetAlpha(self.rTab.a)
	end
	
end

function module:InitTicker()

	if self.runing == true or self.firstTick == 0 then return end
	
	self:StartTicker(2)

	if self.firstTick ~= 0 then
		
		self.diff = GetTime() - self.firstTick
		self.diff = ( self.diff - math.floor( self.diff/2 )*2 ) -- /2
		self.endTime = GetTime() + 2 - self.diff
		self.startTime = GetTime() - self.diff
		
	end
	
end
