local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
if not mHud or not mHud:GetModule("Configuration", true) then return end
local barConfig = [[ return function(db, id, self)

		local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
		local mBar = LibStub("AceAddon-3.0"):GetAddon("mBar")

		local t =  {
			frame = {
				type = "group",
				order = 70,
				name = "Frame",
				childGroups = "tab",
	 			plugins = {},
				args = {
					bgalphaspace1 = { order = 10, type = "header", name = "Frame / Border" },
				},
			},
		}
		
		t.frame.args.frametoggle = {
			type = "toggle",
			name = "Show frame",
			order = 20,
			get = function() return db.frame.active end,
			set = function(info, value) db.frame.active = value; self:UpdateConfig(id) end,
		}
		
		t.frame.args.framespace1 = { order = 30, type = "description", name = " " }
		
		t.frame.args.frametexture = {
			order = 40,
			type = "select",
			name = "Texture",
			get = function() return db.frame.texture end,
			set = function(info, value) db.frame.texture = value; self:UpdateConfig(id) end,
			values = function()
				local td = { }
				for k,_ in pairs(mBar.media.mediaTable.statusbarframe or { }) do
					td[k] = k
				end
				return td
			end,
			disabled = function() return not db.frame.active end,
		}
		
		t.frame.args.framespace2 = { order = 50, type = "description", name = " " }
		
		t.frame.args.offsetx = {
			order = 60,
			type = "range",
			name = "Offset X",
			get = function() return db.frame.offsetX end,
			set = function(info, value) db.frame.offsetX = value; self:UpdateConfig(id) end,
			min = -600, max = 600, bigStep = 1,
		}
		t.frame.args.offsety = {
			order = 70,
			type = "range",
			name = "Offset Y",
			get = function() return db.frame.offsetY end,
			set = function(info, value) db.frame.offsetY = value; self:UpdateConfig(id) end,
			min = -600, max = 600, bigStep = 1,
		}
		
		t.frame.args.dx = {
			order = 80,
			type = "range",
			name = "Padding X",
			get = function() return db.frame.dx end,
			set = function(info, value) db.frame.dx = value; self:UpdateConfig(id) end,
			min = 0, max = 600, bigStep = 1,
		}
		t.frame.args.dy = {
			order = 90,
			type = "range",
			name = "Padding Y",
			get = function() return db.frame.dy end,
			set = function(info, value) db.frame.dy = value; self:UpdateConfig(id) end,
			min = 0, max = 600, bigStep = 1,
		}
		
		
		if mHud:GetModule("GradientColor", true) then
			t.frame.args.framecolornormal = {
				type = "select",
				name = "Colors - Normal",
				order = 100,
				values = mHud.mColorTemplateConfig:List(2, "Normal"),
				get = function() return db.frame.gradientColor end,
				set = function(info, value) db.frame.gradientColor = value; self:UpdateConfig(id) end,
				disabled = function() return not db.frame.active end,
			}
			t.frame.args.framecolorcombat = {
				type = "select",
				name = "Colors - Combat",
				order = 110,
				values = mHud.mColorTemplateConfig:List(2, "Combat", true),
				get = function() return db.frame.gradientColorCombat or "nil" end,
				set = function(info, value) db.frame.gradientColorCombat = value; if value == "nil" then db.frame.gradientColorCombat = nil end; self:UpdateConfig(id) end,
				disabled = function() return not db.frame.active end,
			}
		end
		
		if mHud:GetModule("GradientAlpha", true) then
			t.frame.args.framealphanormal = {
				type = "select",
				name = "Alpha - Normal",
				order = 120,
				values = mHud.mAlphaTemplateConfig:List(2, "Normal"),
				get = function() return db.frame.gradientAlpha end,
				set = function(info, value) db.frame.gradientAlpha = value; self:UpdateConfig(id) end,
				disabled = function() return not db.frame.active end,
			}
			t.frame.args.framealphacombat = {
				type = "select",
				name = "Alpha - Combat",
				order = 130,
				values = mHud.mAlphaTemplateConfig:List(2, "Combat", true),
				get = function() return db.frame.gradientAlphaCombat or "nil" end,
				set = function(info, value) db.frame.gradientAlphaCombat = value; if value == "nil" then db.frame.gradientAlphaCombat = nil end; self:UpdateConfig(id) end,
				disabled = function() return not db.frame.active end,
			}
		end
		
		return t
		end]]
local bulkConfig = nil
local moduleConfig = nil
mHud:GetModule("Configuration"):NewModuleConfig("Frame", moduleConfig, barConfig, bulkConfig)
