local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
local mBar = LibStub("AceAddon-3.0"):GetAddon("mBar")
local module = mHud:NewModule("Frame")

mHud.defaults.profile.bar['*'].frame = {
	active = false,
	offsetX = 0,
	offsetY = 0,
	dx = 0,
	dy = 0,
	texture = "none",
	gradientAlpha = "Frame",
	gradientAlphaCombat = "Frame",
	gradientColor = "Frame",
	gradientColorCombat = "Frame",
	color = { r = 0, g = 0, b = 0, a = 0.50 }
}

module.colorTemplates = {
	Normal = {
		Frame = {
			[1] = { v = 1.0, c = { r = 0.00, g = 0.00, b = 0.00 }},
		},
	},
	Combat = {
		Frame = {
			[1] = { v = 1.0, c = { r = 0.00, g = 0.00, b = 0.00 }},
			[2] = { v = 0.5, c = { r = 0.00, g = 0.00, b = 0.00 }},
			[3] = { v = 0.0, c = { r = 1.00, g = 0.00, b = 0.00 }},
		},
	},
}

module.alphaTemplates = {
	Normal = {
		Frame = {
			[1] = { v = 1.00, c = { a = 0.30, b = "BLEND" }},
			[2] = { v = 0.002, c = { a = 1.00, b = "BLEND" }},
			[3] = { v = 0.001, c = { a = 0.00, b = "BLEND" }},
			[4] = { v = 0.00, c = { a = 0.00, b = "BLEND" }},
		},
	},
	Combat = {
		Frame = {
			[1] = { v = 1.00, c = { a = 1.00, b = "BLEND" }},
			[2] = { v = 0.002, c = { a = 1.00, b = "BLEND" }},
			[3] = { v = 0.001, c = { a = 0.00, b = "BLEND" }},
			[4] = { v = 0.00, c = { a = 0.00, b = "BLEND" }},
		},
	},
}

function module:OnEnable() self:RegisterEvents() end
function module:OnDisable() self:UnegisterEvents() end

function module:RegisterEvents()

	self:RegisterMessage("MBAR_CREATED", "BarCreated")
	self:RegisterMessage("MBAR_CONFIG_UPDATE", "BarConfigChange")
	
end


function module:UnegisterEvents()

	self:UnregisterMessage("MBAR_CREATED")
	self:UnregisterMessage("MBAR_CONFIG_UPDATE")
	
end


function module:BarCreated(_, f)
	if f.db.frame.active then
		self:Debug("BarCreated")
		if not f.frame then f.frame = f:CreateTexture(nil, "OVERLAY") end
		f.frame:SetVertexColor(f.db.frame.color.r, f.db.frame.color.g, f.db.frame.color.b, f.db.frame.color.a)
	end
end

function module:BarConfigChange(_, f)
	if f.db.frame.active then
		if not f.frame then self:BarCreated(_, f) end
		f.frame:SetPoint("CENTER", f, "CENTER", f.db.frame.offsetX, f.db.frame.offsetY)
		f.frame:SetHeight(f:GetHeight() + f.db.frame.dy)
		f.frame:SetWidth(f:GetWidth() + f.db.frame.dx)
		
		f.frame:SetTexture((mBar.media.mediaTable.statusbarframe and mBar.media.mediaTable.statusbarframe[f.db.frame.texture]) or f.db.frame.texture)
		mBar:PaintTexture(f.frame, 0, 1)
		f.frame:Show()
	else
		if f.frame then f.frame:Hide() end
	end
end

function module:OnPaint(_, f) f.frame:SetVertexColor(f.bar:GetVertexColor()) end

