local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
if not mHud or not mHud:GetModule("Configuration", true) then return end

mHud.mAlphaTemplateConfig = { }
mHud.mTemplateConfig:Embed(mHud.mAlphaTemplateConfig)
mHud.mAlphaTemplateConfig.modId = "alpha"
mHud.mAlphaTemplateConfig.modName = "GradientAlpha"
mHud.mAlphaTemplateConfig.newTpl = { v = 1.0, c = { a = 1.00, b = "BLEND" }}

local mAlphaTemplateConfig = mHud.mAlphaTemplateConfig

function mAlphaTemplateConfig:EditTemplateConfig(t, id, v)

	self.temp[id].c.a = v.a
	self.temp[id].c.b = v.b

	t['alpha'..id] = {
		order = id*10+1,
		type = "range",
		name = "Alpha",
		get = function() return self.temp[id].c.a end,
		set = function(info, value) self.temp[id].c.a = value end,
		min = 0, max = 1, bigStep = 0.01,
	}
	t['alpha'..id..'space'] = {
		order = id*10+2,
		type = "description",
		name = " ",
	}

end

local barConfig = [[ return function(db, id, self)
		local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
		return {
			look = {
				gradientalpha = {
					--barlook = { order = 140, type = "header", name = "Bar" },
					alphanormal = {
						type = "select",
						name = "Alpha - Normal",
						order = 40,
						values = mHud.mAlphaTemplateConfig:List(2, "Normal"),
						get = function() return db.gradientAlpha end,
						set = function(info, value) db.gradientAlpha = value; self:UpdateConfig(id) end,
					},
					alphacombat = {
						type = "select",
						name = "Alpha - Combat",
						order = 41,
						values = mHud.mAlphaTemplateConfig:List(2, "Combat", true),
						get = function() return db.gradientAlphaCombat or "nil" end,
						set = function(info, value) db.gradientAlphaCombat = value; if value == "nil" then db.gradientAlphaCombat = nil end; self:UpdateConfig(id) end,
					},
					alphaspace =  {
						order = 42,
						type = "description",
						name = " ",
					},
				},
			},
		} end]]
local bulkConfig = nil
local moduleConfig = [[ return function(name, self)
		local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
		local t = {
			normal = {
				type = "select",
				name = "Templates - Normal",
				order = 5,
				values = mHud.mAlphaTemplateConfig:List(1, "Normal"),
				get = function() if mHud.mAlphaTemplateConfig.editBranch == "Normal" then return mHud.mAlphaTemplateConfig.editName else return false end end,
				set = function(info, value)
					mHud.mAlphaTemplateConfig.editName = value
					mHud.mAlphaTemplateConfig.editBranch = "Normal"
					self:WriteConfig()
				end,
			},
			combat = {
				type = "select",
				name = "Templates - Combat",
				order = 6,
				values = mHud.mAlphaTemplateConfig:List(1, "Combat"),
				get = function() if mHud.mAlphaTemplateConfig.editBranch == "Combat" then return mHud.mAlphaTemplateConfig.editName else return false end end,
				set = function(info, value)
					mHud.mAlphaTemplateConfig.editName = value
					mHud.mAlphaTemplateConfig.editBranch = "Combat"
					self:WriteConfig()
				end,
			},
			topspace =  {
				order = 7,
				type = "description",
				name = " ",
			},
		}
		
		mHud.mAlphaTemplateConfig:EditTemplate(t)
		
		return t
		end]]
mHud:GetModule("Configuration"):NewModuleConfig("GradientAlpha", moduleConfig, barConfig, bulkConfig)
