local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
if not mHud or not mHud:GetModule("Configuration", true) then return end

mHud.mColorTemplateConfig = { }
mHud.mTemplateConfig:Embed(mHud.mColorTemplateConfig)
mHud.mColorTemplateConfig.modId = "color"
mHud.mColorTemplateConfig.modName = "GradientColor"
mHud.mColorTemplateConfig.newTpl = { v = 1.0, c = { r = 1.00, g = 1.00, b = 1.00 }}

local mColorTemplateConfig = mHud.mColorTemplateConfig

function mColorTemplateConfig:EditTemplateConfig(t, id, v)

	self.temp[id].c.r = v.r
	self.temp[id].c.g = v.g
	self.temp[id].c.b = v.b

	t['color'..id] = {
		order = id*10+1,
		type = "color",
		name = "Color",
		get = function() return self.temp[id].c.r, self.temp[id].c.g, self.temp[id].c.b end,
		set = function(info, r, g, b)
			self.temp[id].c.r = r
			self.temp[id].c.g = g
			self.temp[id].c.b = b
		end,
		hasAlpha = false,
	}
	t['color'..id..'space'] = {
		order = id*10+2,
		type = "description",
		name = " ",
	}

end

local barConfig = [[ return function(db, id, self)
		local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
		return {
			look = {
				gradientcolor = {
					--barlook = { order = 140, type = "header", name = "Bar" },
					colornormal = {
						type = "select",
						name = "Colors - Normal",
						order = 30,
						values = mHud.mColorTemplateConfig:List(2, "Normal"),
						get = function() return db.gradientColor end,
						set = function(info, value) db.gradientColor = value; self:UpdateConfig(id) end,
					},
					colorcombat = {
						type = "select",
						name = "Colors - Combat",
						order = 31,
						values = mHud.mColorTemplateConfig:List(2, "Combat", true),
						get = function() return db.gradientColorCombat or "nil" end,
						set = function(info, value) db.gradientColorCombat = value; if value == "nil" then db.gradientColorCombat = nil end; self:UpdateConfig(id) end,
					},
					colorspace =  {
						order = 32,
						type = "description",
						name = " ",
					},
				},
			},
		} end]]
local bulkConfig = nil
local moduleConfig = [[ return function(name)
		local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
		local t = {
			normal = {
				type = "select",
				name = "Templates - Normal",
				order = 5,
				values = mHud.mColorTemplateConfig:List(1, "Normal"),
				get = function() if mHud.mColorTemplateConfig.editBranch == "Normal" then return mHud.mColorTemplateConfig.editName else return false end end,
				set = function(info, value)
					mHud.mColorTemplateConfig.editName = value
					mHud.mColorTemplateConfig.editBranch = "Normal"
					mHud:GetModule("Configuration"):WriteConfig()
				end,
			},
			combat = {
				type = "select",
				name = "Templates - Combat",
				order = 6,
				values = mHud.mColorTemplateConfig:List(1, "Combat"),
				get = function() if mHud.mColorTemplateConfig.editBranch == "Combat" then return mHud.mColorTemplateConfig.editName else return false end end,
				set = function(info, value)
					mHud.mColorTemplateConfig.editName = value
					mHud.mColorTemplateConfig.editBranch = "Combat"
					mHud:GetModule("Configuration"):WriteConfig()
				end,
			},
			topspace =  {
				order = 7,
				type = "description",
				name = " ",
			},
		}
		
		mHud.mColorTemplateConfig:EditTemplate(t)

		return t
		end]]
mHud:GetModule("Configuration"):NewModuleConfig("GradientColor", moduleConfig, barConfig, bulkConfig)
