if select(2, UnitClass("player")) ~= "DRUID" and UnitPowerType("player") ~= 0 then return end

local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
local module = mHud:NewModule("ManaTicker")
mHud.mPowerTicker:Embed(module)

mHud.defaults.profile.bar['*'].manaticker = {
	gradientColor = "ManaTicker",
	gradientAlpha = "ManaTicker",
}

module.rTab = { }

module.colorTemplates = {
	Normal = {
		ManaTicker = {
			[1] = { v = 1.0, c = { r = 1.00, g = 1.00, b = 1.00 }},
		},
	},
}

module.alphaTemplates = {
	Normal = {
		ManaTicker = {
			[1] = { v = 1.00, c = { a = 1.00, b = "BLEND" }},
			[2] = { v = 0.50, c = { a = 1.00, b = "BLEND" }},
			[3] = { v = 0.10, c = { a = 0.00, b = "BLEND" }},
			[4] = { v = 0.00, c = { a = 0.00, b = "BLEND" }},
		},
	},
}


function module:OnTickerEnable()
	self.event:SetScript("OnEvent", function() self:OnEvent() end)
	self:RegisterEvents()
end

function module:OnTickerDisable() self:UnregisterEvents() end

function module:RegisterEvents()
	self.event:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
end

function module:UnregisterEvents()
	self.event:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
end

function module:OnEvent()
	if arg1 == "player" and UnitMana("player") ~= UnitManaMax("player") and UnitPowerType("player") == 0 then self:InitTicker() end
end

function module:OnTickerUpdate(f)

	if f.db.manaticker.gradientColor and mHud:GetModule("GradientColor", true) then
		self.rTab = mHud:GetModule("GradientColor"):GetProfile(f, f.db.manaticker.gradientColor, f.db.manaticker.gradientColorCombat, self.pos)
		f.ticker:SetVertexColor(self.rTab.r, self.rTab.g, self.rTab.b)
	end
	if f.db.manaticker.gradientAlpha and mHud:GetModule("GradientAlpha", true) then
		self.rTab = mHud:GetModule("GradientAlpha"):GetProfile(f, f.db.manaticker.gradientAlpha, f.db.manaticker.gradientAlphaCombat, self.pos)
		f.ticker:SetAlpha(self.rTab.a)
	end
	
end

function module:InitTicker()

	if self.lastTick == 0 then
		self:StartTicker(5)
	else
		self.diff = GetTime() - self.lastTick
		self.diff = 2 - ( self.diff - math.floor( self.diff/2 )*2 )
		--Debug(5 .. " + " ..module.diff.." = "..(5+module.diff)) 
		if self.diff > 1 then
			self:StartTicker(5 + self.diff - 1)
		else
			self:StartTicker(5 + self.diff + 1)
			self.timeLeft = 5 + self.diff + 1
		end
	end
	
end
