local mBar = LibStub("AceAddon-3.0"):GetAddon("mBar")
local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
local module = mBar:NewModule("Power")
module.events = { "UNIT_MANA", "UNIT_RAGE", "UNIT_ENERGY" }
module.description = "Mana/Rage/Energy/Focus"

module.colorTemplates = {
	Normal = {
		Mana = {
			[1] = { v = 1.0, c = { r = 0.00, g = 0.00, b = 1.00 }},
			[2] = { v = 0.0, c = { r = 0.50, g = 0.50, b = 1.00 }},
		},
		Rage = {
			[1] = { v = 1.0, c = { r = 1.00, g = 0.50, b = 0.50 }},
			[2] = { v = 0.0, c = { r = 1.00, g = 0.00, b = 0.00 }},
		},
		Energy = {
			[1] = { v = 1.0, c = { r = 1.00, g = 1.00, b = 0.00 }},
			[2] = { v = 0.0, c = { r = 1.00, g = 0.50, b = 0.00 }},
		},
		Focus = { -- Not the correct color, just some random stuff
			[1] = { v = 1.0, c = { r = 1.00, g = 0.00, b = 1.00 }},
			[2] = { v = 0.0, c = { r = 1.00, g = 0.00, b = 0.00 }},
		},
	},
}

module.alphaTemplates = {
	Normal = {
		Rage = {
			[1] = { v = 1.00, c = { a = 0.60, b = "BLEND" }},
			[2] = { v = 0.00, c = { a = 1.00, b = "BLEND" }},
		},
	},
	Combat = {
		Energy = {
			[1] = { v = 1.00, c = { a = 0.60, b = "BLEND" }},
		},
		Rage = {
			[1] = { v = 1.00, c = { a = 1.00, b = "BLEND" }},
		},

	},
}

function module:GetUnitValue(unit)
	if UnitManaMax(unit) > 0 then return UnitMana(unit) / UnitManaMax(unit) end
	return 0
end

function module:GetUnitMax(unit)
	return UnitManaMax(unit)
end

function module:GetColor(f)
	if (UnitPowerType(f.db.unit) == 1) then
		return 1, 0, 0 -- rage
	elseif (UnitPowerType(f.db.unit) >= 3) then
		return 1, 1, 0 -- energy
	else
		return 0, 0, 1 -- mana
	end
end
