local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
local skin = mHud.skin:NewModule("cArch")

skin.description = {
	Default = "The new default skin. Player on the left, and target on the right.",
	Thin = "A minimalistic skin. Player on the left, and target on the right.",
}

skin.defaults = {
	bar = {
		['*'] = {
		
			type = "Health",
			unit = "player",
			
			offsetX = 0,
			offsetY = 0,
			
			width = 64*0.6,
			height = 256*0.6,
			
			texture = "cArch",
			
			frame = {
				active = true,
				texture = "cArchFrame"
			},
			
			anchor = {
				to = "UIParent", -- default hpbar
				point = "CENTER",
				relative = "CENTER",
			},
			
			text = {
				--gradientAlphaCombat = "Default",
			},
			
			
		}
	}
}

skin.profiles = {

	Default = {
		[1] = {
			active = true,
			type = "Health",
			unit = "player",
			
			offsetX = -100,
			offsetY = 30,
			
			text = {
				[1] = {
					tag = "[CurHP]",
					
					offsetX = -10,
					offsetY = 0,
					
					anchor = {
						to = 1,
						point = "LEFT",
						relative = "RIGHT",
					},
				}
			},
			
			abyss = { 
				active = true,
				
				gradientColor = "Abyss",
				gradientAlpha = "Abyss",

				text = {
					active = true,
					
					size = 12,
					
					offsetX = 15,
					offsetY = 0,
					
					color = {
						r = 1,
						g = 0,
						b = 0,
						a = 1
					},
					anchorToSpark = true,
				},
			},
			
		},
		[2] = {
			active = true,
			type = "Power",
			unit = "player",
			
			offsetX = 24,
			offsetY = 0,
			
			anchor = {
				to = 1, -- default hpbar
				point = "RIGHT",
				relative = "LEFT",
			},
			
			frame = {
				active = true,
				gradientColorCombat = "Black",
				gradientAlphaCombat = "Bright",
			},
			
			text = {
				{
					tag = "[CurMP:HideZero]",
					
					offsetX = 0,
					offsetY = 0,
					
					anchor = {
						to = 2,
						point = "RIGHT",
						relative = "LEFT",
					},
				}
			},
			
		},
		[3] = {
			active = true,
			type = "Power",
			unit = "target",
			
			offsetX = 100,
			offsetY = 30,

			textureMirror = true,
			
			text = {
				{
					tag = "[CurMP:HideZero]",
					
					offsetX = 0,
					offsetY = 0,
					
					anchor = {
						to = 3, -- default hpbar
						point = "LEFT",
						relative = "RIGHT",
					},
				}
			},
			
		},
		[4] = {
			active = true,
			type = "Health",
			unit = "target",
			
			offsetX = 24,
			offsetY = 0,
			
			textureMirror = true,
			
			gradientColor = "AUTO_HOSTILE",
			
			anchor = {
				to = 3, -- default hpbar
				point = "RIGHT",
				relative = "LEFT",
			},
			
			text = {
				{
					tag = "[CurHP:Short]",
					
					offsetX = 10,
					offsetY = 0,
					
					anchor = {
						to = 4, -- default hpbar
						point = "RIGHT",
						relative = "LEFT",
					},
				},
			},
		},
		[5] = {
			active = true,
			unit = "player",
			type = "ComboPoint",
			
			offsetX = -10,
			offsetY = 0,
			
			width = 21,
			height = 90,
			
			texture = "cArchCombo",
			textureMirror = true,
			
			gradientAlphaCombat = "ComboPoint",
			
			frame = {
				active = false,
			},
			
			background = {
				gradientAlpha = "AUTO_POWER",
				gradientAlphaCombat = "Background",
				gradientColorCombat = "White",
			},
			
			anchor = {
				to = 2,
				point = "TOPRIGHT",
				relative = "TOPRIGHT",
			},
		
		},
		[6] = {
			active = true,
			type = "DruidMana",
			
			width = 19.2,
			offsetX = -10,
			
			texture = "cArchThin",
			
			anchor = {
				to = 2,
			},
			
			text = {
				{
					tag = "[CurDruidMP]",
					size = 8,
					
					offsetX = -5,
					offsetY = -10,
					
					anchor = {
						point = "RIGHT",
						to = 6,
						relative = "LEFT",
					},
				},
			},
			
			frame = {
				active = true,
				texture = "cArchThinFrame",
			},
		},
	},
	
	Thin = {
		[1] = {
			active = true,
			
			width = 19.2,
			
			offsetX = -100,
			offsetY = 30,
			
			texture = "cArchThin",
			
			gradientAlphaCombat = "Bright",
			
			frame = {
				active = false,
				texture = "cArchThinFrame",
			},
			
			text = {
				{
					size = 12,
					offsetX = -5,
					
					gradientAlphaCombat = "Bright",
					
					anchor = {
						relative = "LEFT",
						point = "RIGHT",
						to = 1,
					},
				},
			},
		},
		[2] = {
			active = true,
			type = "Power",
			
			width = 19.2,
			
			offsetX = -15.8,
			offsetY = 0,
			
			texture = "cArchThin",
			gradientAlphaCombat = "Bright",
			
			anchor = {
				relative = "RIGHT",
				to = 1,
				point = "LEFT",
			},

			text = {
				{
					size = 12,
					offsetX = -10,
					
					tag = "[CurMP:HideZero]",
					
					gradientAlphaCombat = "Bright",
					
					anchor = {
						relative = "RIGHT",
						point = "LEFT",
						to = 2,
					},
				},
			},
			
			frame = {
				active = false,
				texture = "cArchThinFrame",
			},
			
		},
		[3] = {
			active = true,
			unit = "target",
			type = "Power",
			
			width = 19.2,
			
			offsetX = 100,
			offsetY = 30,
			
			texture = "cArchThin",
			textureMirror = true,
			
			gradientAlphaCombat = "Bright",
			
			text = {
				{
					size = 12,
					offsetX = 5,
					tag = "[CurMP:HideZero]",
					gradientAlphaCombat = "Bright",
					anchor = {
						relative = "RIGHT",
						point = "LEFT",
						to = 3,
					},
				},
			},
			
			frame = {
				active = false,
				texture = "cArchThinFrame",
			},
		},
		[4] = {
			active = true,
			unit = "target",
			
			width = 19.2,
			
			offsetX = -22.7,
			offsetY = 0,
			
			texture = "cArchThin",
			textureMirror = true,
			
			gradientColor = "AUTO_HOSTILE",
			gradientAlphaCombat = "Bright",
			
			anchor = {
				relative = "RIGHT",
				point = "LEFT",
				to = 3,
			},
			
			text = {
				{
					size = 12,
					offsetX = 5,
					gradientAlphaCombat = "Bright",
					anchor = {
						relative = "LEFT",
						point = "RIGHT",
						to = 4,
					},
				},
			},
			
			frame = {
				active = false,
				texture = "cArchThinFrame",
			},
		},
		[5] = {
			active = true,
			unit = "player",
			type = "ComboPoint",
			
			offsetX = 10,
			offsetY = 0,
			
			width = 21,
			height = 90,
			
			texture = "cArchCombo",
			
			frame = { active = false },
			
			background = {
				gradientAlpha = "AUTO_POWER",
				gradientAlphaCombat = "Background",
				gradientColorCombat = "White",
			},
			
			anchor = {
				to = 4,
				point = "TOPRIGHT",
				relative = "TOPRIGHT",
			},
		},
		[6] = {
			active = true,
			unit = "target",
			
			width = 19.2,
			
			offsetX = -3.5,
			offsetY = 0,
			
			texture = "cArchThin",
			textureMirror = true,
			
			gradientColor = "AUTO_CLASS",
			gradientAlphaCombat = "Bright",
			
			anchor = {
				to = 4,
			},
			
			text = {
				{
					size = 12,
					offsetX = 5,
					gradientAlphaCombat = "Bright",
					anchor = {
						relative = "LEFT",
						point = "RIGHT",
						to = 4,
					},
				},
			},
			
			frame = {
				active = false,
				texture = "cArchThinFrame",
			},
		},
	},


}