local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")

if mHud.mPowerTicker then return end
if not mHud.mTicker then error("mPowerTicker requires mTicker"); return end

mHud.mPowerTicker = { }
local mPowerTicker = mHud.mPowerTicker

mHud.mTicker:Embed(mPowerTicker)
mPowerTicker.active = true
mPowerTicker.type = 0

function mPowerTicker:OnEnable()
	if not self.event then self.event = CreateFrame("Frame") end
	if not self.powerEvent then
		self.powerEvent = CreateFrame("Frame")
		self.powerEvent:SetScript("OnEvent", function() self:OnPowerEvent() end)
	end
	self.class = select(2, UnitClass("player"))
	self:PowerRegisterEvents()
	self:OnTickerEnable()
end


function mPowerTicker:OnTickerEnable() end -- Local Enable
function mPowerTicker:OnTickerDisable() end -- Local Disable


function mPowerTicker:PowerRegisterEvents()
	self:RegisterMessage("MBAR_PAINT", "OnPowerPaint")
	self:RegisterMessage("MBAR_CONFIG_UPDATE", "PowerBarConfigChange")
	if self.class == "DRUID" then self.powerEvent:RegisterEvent("UPDATE_SHAPESHIFT_FORM") end -- Monitor shapeshifts
end


function mPowerTicker:OnDisable()
	self:OnTickerDisable()
	self:PowerUnregisterEvents()
end


function mPowerTicker:PowerUnregisterEvents()
	self:UnregisterMessage("MBAR_PAINT")
	self:UnregisterMessage("MBAR_CONFIG_UPDATE")
	if self.class == "DRUID" then self.powerEvent:UnregisterEvent("UPDATE_SHAPESHIFT_FORM") end -- Monitor shapeshifts
end


function mPowerTicker:PowerBarConfigChange(_, f)
	if f.db.unit == "player" and f.db.type == "Power" then self:AddFrame(f) else self:RemoveFrame(f) end
end


function mPowerTicker:OnPowerPaint(_, f)
	if f.oldValue and f.value > f.oldValue then self.lastTick = GetTime() end -- Managain, prob tick
end


function mPowerTicker:OnPowerEvent()
	if event == "UPDATE_SHAPESHIFT_FORM" then
		if UnitPowerType("player") == self.type then self.active = true else self.active = false end
		--self:Debug("Changed form, set to: "..(self.active and "Active" or "Disabled"), true)
	end
end
