local mHud = LibStub("AceAddon-3.0"):GetAddon("mHud")
local mBar = LibStub("AceAddon-3.0"):GetAddon("mBar")
mHud.skin = LibStub("AceAddon-3.0"):NewAddon("mHud-Skin")

local skin = mHud.skin
skin.media = mBar.media
skin.skin = nil
skin.scheme = nil
skin.profile = "Default"
skin.reset = false
skin.defaults = { profile = { } }

function skin:FindDefault()

	--mHud:Debug("skin:FindDefault", true)

	-- There are saved variables
	if mHudDB then
	
		if mHudDB['profileKeys'] then
	
			-- Get profilename
			local profileKey = UnitName("player") .. " - " .. GetRealmName()
			skin.profile = mHudDB['profileKeys'][profileKey] or "Default"
			
			if mHudDB['profiles'][skin.profile] then
				self.skin = mHudDB['profiles'][self.profile].skin
				self.scheme = mHudDB['profiles'][self.profile].scheme or "Default"
			end
			
		else
			mHudDB = { } -- remove old saved variables
			
		end
	end
	
	-- Default skin
	if not self.skin or not self:GetModule(self.skin, true) then
		-- Set default profile
		for _,s in pairs({"cArch", "dArch"}) do
			if self:GetModule(s, true) then self.skin = s; break end
		end
		
		-- Still no default skin
		if not self.skin then
			-- Use the first skin we can find
			for name, module in self:IterateModules() do
				self.skin = name
				break
			end
		end
		
	end
	
	--if self.skin then mHud:Debug("Skin found: "..self.skin, true) end
	--if self.scheme then mHud:Debug("Scheme found: "..self.scheme, true) end
	
end


function skin:Init()
	
	-- Setting defaults
	--mHud:Debug("skin:Init", true)
	
	self:FindDefault()
	if not self.skin then error("mHud: No skins, this addon requires atleas one skin to work."); return end
	self.handler = self:GetModule(self.skin)

	skin.defaults = { profile = { } } -- reset
	self.defaults = { }

	mHud:CopyTable(self.defaults, mHud.defaults)
	mHud:CopyTable(self.defaults.profile, self.handler.defaults)
	
end


function skin:Load()
	
	--mHud:Debug("skin:Load", true)

	-- If not bars, or reset
	if not (mHudDB.profiles and mHudDB.profiles[self.profile] and mHudDB.profiles[self.profile].bar) or self.reset then
	
		mHud:Debug("No profile ("..self.profile.."), restoring defaults: "..(self.skin or "NoSkin").." - "..(self.scheme or "Default"), true)
		if not self.handler.profiles[self.scheme or "Default"] then error("Skin '"..mHud.db.profile.skin.." has no '"..(self.scheme or "Default").."' layout, plz read the documentation.") end
		mHud:SaveToDb(mHud.db.profile, self.handler.profiles[self.scheme or "Default"], "bar")
		
		--mHud:Debug("skin:Load, copy stuff!", true)
		
	end

	mHud.db.profile.skin = self.skin
	mHud.db.profile.scheme = self.scheme
	
end
